require 'rails_helper'
require 'vcr_config'

# exemple d'utilisation
=begin
a1 = Hermes::Applicant.create( monthly_charges: {},nationality:"1",)
        work_contract_type: "Agents publics",
        has_other_employers: true,
        year_minus_one: Date.current.year,
        amount_year_minus_one: "123",
        birth_date:Date.current,

        family_situation:"Mariée",
        civility:"Monsieur",user:User.first)

hr = Hermes::HousingRequest.create(  is_active: true,main_applicant: a1)
          id_counter: "alpha",
          internal_ref: "alpha",
          sne_creation_date: DateTime.new,
          forcing_duplicate: true,
          electronical_renewal: true,
          seeked_housing_categories: ["alpha"],
          seeking_first_floor: true,
          seeking_elevator: true,
          seeked_max_rent: 451,
          widen_request: true,
          seeked_types: ["alpha", "bravo"],
          seeked_districts: ["30100", "30100"],
          seeked_district_postal_codes: ["30100", "30101"],
          actual_housing_details:{'appartment_staircase': "33","host": 'A',"housing_surface": "200",'appartment_building':"A","housing_typology":"1","address_add_address":"à droite  con !!!!!!!!!!!","housing_apl":"120","housing_resident_nb": "2", "housing_rent_amount": "380",'address_actual_housing_details':{"code":30100}},
          postal_details:{'appartment_number':30,"host": 'A', 'address_postal_details':{'code': "30100"}},
          requester_lastname: "alpha",
          requester_firstname: "alpha",
          is_house_owner: true,
          motivation3: "Démolition")


hr= Hermes::HousingRequest.find("5e6ba24ba70bf23a477859d1")

so=Hermes::BoClient::AddRequestTask.new({:'housing_request_id'=> hr.id})
so.to_xml
ExecuteSopraTaskJob.perform_now(so.endpoint, so.to_xml)
=end

dir_path = File.dirname(__FILE__)
schema_path = [dir_path, 'InterfaceNuu_v0300.xsd'].join('/')
require [Hermes::Engine.root, %w[lib hermes bo_client tasks]].flatten.join('/').to_s

RSpec.describe Hermes::BoClient::AddRequestTask, type: :helper do
  let!(:xsd) { Nokogiri::XML::Schema(File.read(schema_path)) }
  let!(:user1) { create(:user) }
  let!(:applicant1) {
    create(
        :applicant,
        user: user1,
        monthly_charges: {},
        work_contract_type: "AGP",
        has_other_employers: true,
        nationality: "1",
        family_situation:'V',
        year_minus_one: Date.current.year,
        amount_year_minus_one: "123",
        birth_date:Date.current,
        civility:"1",
        sne_profile_creation_date: Date.current - 20.days,
        actual_housing_details:{
=begin
            'appartment_staircase': "33",

            "housing_surface": "200",
            'appartment_building': "A",

            "address_add_address":"à droite  con !!!!!!!!!!!",
            "housing_apl":"120","housing_resident_nb": "2",
            "housing_rent_amount": "380",
            'address_actual_housing_details':{"code":30100},
            'appartment_floor':'1',
=end

"housing_typology":"1",
            "address_number": "36",
            "address_street": "Allée de ta mere" ,
           # appartment_address_place: " ",
            postal_code:"29000",
            address_insee_code: "29000"
        },

        )
  }

  it 'should load a valid XSD' do
    expect(xsd).to be_present
    expect(xsd.class).to be Nokogiri::XML::Schema
  end

  context 'with simple housing_request' do
    let!(:applicant) {create(:applicant)}


    let!(:housing_request1) do
      create(
          :housing_request,
          is_active: true,
          main_applicant: applicant1,
          id_counter: "alpha",

          internal_ref: "alpha",
          seeked_localisation_list: [
              {
                  "nom": "Fréjus",
                  "code": "83061",
                  "codeDepartement": "83",
                  "codeRegion": "93",
                  "codesPostaux": [
                      "83600",
                      "83370"
                  ],
                  "population": 53168,
                  "_score": 1
              },
              {
                  "nom": "Fréjzus",
                  "code": "84061",
                  "codeDepartement": "81",
                  "codeRegion": "92",
                  "codesPostaux": [
                      "80600",
                      "80370"
                  ],
                  "population": 53168,
                  "_score": 1
              },
          ],
          forcing_duplicate: true,
          electronical_renewal: true,
          seeked_housing_categories: ["J"],
          seeking_first_floor: true,
          seeking_elevator: true,
          seeked_max_rent: 451,

          widen_request: true,
          seeked_types: ["T1", "T2"],
          typology_range: ["T1"],
          housing_type_list:["HLM"],
         postal_details:{
             'appartment_number':30,
             "host": 'A',
             'address_postal_details':{'code': "30100"},
             'appartment_floor':'1',
             "address_number": "36",
             "address_street": "Allée de ta mere",
             appartment_address_place: " ",
             postal_code:"29000",
             address_insee_code:"29199"
         },
          requester_lastname: "alpha",
          requester_firstname: "alpha",
          is_house_owner: true,
          motivation1: "02",
          motivation3: "01",

      )
    end
    let!(:nud3) do
      create(
          :nud,
          housing_request: housing_request1,
          department: '14',
          creation_date: '2017-23-14T14:53:22',
          unique_number:"54739274"
      )
    end

    describe 'using to_xml' do
      let!(:add_request_task1) do
        build(
            :add_request_task,
            options: {nud_id: housing_request1.nud_ids[0] ,housing_request_id: housing_request1.reload.id }
        )
      end
      it 'should return a valid xml' do
        xsd.validate(Nokogiri::XML(add_request_task1.to_xml))
        add_request_task1.validate_xml
        expect(housing_request1.reload.last_xml_validation_report).to eq("[]")
        so=Hermes::BoClient::AddRequestTask.new({:'housing_request_id'=> housing_request1.id})
        so.execute
        VCR.use_cassette("flux30", :match_requests_on => [:method, :uri, :path]) do
          perform_enqueued_jobs do
            enqueued_jobs.each {|job| job[:job].perform_now(*job[:args])}
          end
        end
        expect(housing_request1.reload.last_error_responses.length).to eq(1)
        expect(housing_request1.reload.last_send_has_error).to eq(true)
        
        expect(xsd.validate(Nokogiri::XML(add_request_task1.to_xml)).length).to eq(0)
      end
    end
  end
end
=begin
[
#<Nokogiri::XML::SyntaxError: 16:0: ERROR: Element '{http://nuu.application.i2/}categorieLogementRecherche', attribute 'code': [facet 'pattern'] The value '' is not accepted by the pattern '[a-zA-Z0-9]{1,6}'.>,
#<Nokogiri::XML::SyntaxError: 18:0: ERROR: Element '{http://nuu.application.i2/}listeTypeLogement': Missing child element(s). Expected is ( {http://nuu.application.i2/}typeLogement ).>,
#<Nokogiri::XML::SyntaxError: 25:0: ERROR: Element '{http://nuu.application.i2/}principauxMotifDemande': Missing child element(s). Expected is one of ( {http://nuu.application.i2/}compDateJugement, {http://nuu.application.i2/}compAutreMotif, {http://nuu.application.i2/}motifDemande ).>,
#<Nokogiri::XML::SyntaxError: 38:0: ERROR: Element '{http://nuu.application.i2/}codePostal': [facet 'pattern'] The value 'jhh' is not accepted by the pattern '[0-9]{1,5}'.>,
#<Nokogiri::XML::SyntaxError: 55:0: ERROR: Element '{http://nuu.application.i2/}commune': This element is not expected. Expected is one of ( {http://nuu.application.i2/}appartement, {http://nuu.application.i2/}etage, {http://nuu.application.i2/}escalier, {http://nuu.application.i2/}batiment, {http://nuu.application.i2/}compAdresse, {http://nuu.application.i2/}numero, {http://nuu.application.i2/}voie ).>,
#<Nokogiri::XML::SyntaxError: 58:0: ERROR: Element '{http://nuu.application.i2/}listeModeleLogement': Missing child element(s). Expected is ( {http://nuu.application.i2/}modeleLogement ).>,
#<Nokogiri::XML::SyntaxError: 59:0: ERROR: Element '{http://nuu.application.i2/}etranger': This element is not expected. Expected is one of ( {http://nuu.application.i2/}compNomOrgBailleur, {http://nuu.application.i2/}compSIRENOrgBailleur, {http://nuu.application.i2/}compResSocDepuis, {http://nuu.application.i2/}compResHotDepuis, {http://nuu.application.i2/}compSousLocDepuis, {http://nuu.application.i2/}compStructDepuis, {http://nuu.application.i2/}compNomStructure, {http://nuu.application.i2/}compCentreDepuis, {http://nuu.application.i2/}compNomCentre, {http://nuu.application.i2/}montantMensuelLoyer ).>]

"[
#<Nokogiri::XML::SyntaxError: 16:0: ERROR: Element '{http://nuu.application.i2/}categorieLogementRecherche', attribute 'code': [facet 'pattern'] The value '' is not accepted by the pattern '[a-zA-Z0-9]{1,6}'.>,
#<Nokogiri::XML::SyntaxError: 18:0: ERROR: Element '{http://nuu.application.i2/}listeTypeLogement': Missing child element(s). Expected is ( {http://nuu.application.i2/}typeLogement ).>,
#<Nokogiri::XML::SyntaxError: 25:0: ERROR: Element '{http://nuu.application.i2/}principauxMotifDemande': Missing child element(s). Expected is one of ( {http://nuu.application.i2/}compDateJugement, {http://nuu.application.i2/}compAutreMotif, {http://nuu.application.i2/}motifDemande ).>,
#<Nokogiri::XML::SyntaxError: 55:0: ERROR: Element '{http://nuu.application.i2/}commune': This element is not expected. Expected is one of ( {http://nuu.application.i2/}appartement, {http://nuu.application.i2/}etage, {http://nuu.application.i2/}escalier, {http://nuu.application.i2/}batiment, {http://nuu.application.i2/}compAdresse, {http://nuu.application.i2/}numero, {http://nuu.application.i2/}voie ).>,
#<Nokogiri::XML::SyntaxError: 58:0: ERROR: Element '{http://nuu.application.i2/}listeModeleLogement': Missing child element(s). Expected is ( {http://nuu.application.i2/}modeleLogement ).>,
#<Nokogiri::XML::SyntaxError: 59:0: ERROR: Element '{http://nuu.application.i2/}etranger': This element is not expected. Expected is one of ( {http://nuu.application.i2/}compNomOrgBailleur, {http://nuu.application.i2/}compSIRENOrgBailleur, {http://nuu.application.i2/}compResSocDepuis, {http://nuu.application.i2/}compResHotDepuis, {http://nuu.application.i2/}compSousLocDepuis, {http://nuu.application.i2/}compStructDepuis, {http://nuu.application.i2/}compNomStructure, {http://nuu.application.i2/}compCentreDepuis, {http://nuu.application.i2/}compNomCentre, {http://nuu.application.i2/}montantMensuelLoyer ).>]"


"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<interfaceNuu xmlns=\"http://nuu.application.i2/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" versionInterface=\"03.00\">\n  <entete>\n    <typeFichier>CRE</typeFichier>\n    <dateFichier>2019-12-31T15:00:07+01:00</dateFichier>\n  </entete>\n  <demande>\n    <demandeLogement>\n      <numGuichet>G1175</numGuichet>\n      <refInterne>b3817b9d135520aaa4</refInterne>\n      <dateCreationDemande>2019-12-24</dateCreationDemande>\n      <forcerDoublon>0</forcerDoublon>\n      <renouvellementElec>1</renouvellementElec>\n      <precision/>\n      <logementRecherche>\n        <categorieLogementRecherche code=\"J\"/>\n        <rezDeChaussee>0</rezDeChaussee>\n        <sansAscenseur>0</sansAscenseur>\n        <demandeElargie>0</demandeElargie>\n        <listeTypeLogement>\n          <typeLogement code=\"T1\"/>\n        </listeTypeLogement>\n        <listeLocalisationSouhaite>\n          <localisationSouhaite>\n            <commune code=\"75113\"/>\n            <codePostal>75113</codePostal>\n          </localisationSouhaite>\n        </listeLocalisationSouhaite>\n      </logementRecherche>\n      <principauxMotifDemande>\n        <motifDemande code=\"02\"/>\n      </principauxMotifDemande>\n      <personnePhysique>\n        <demandeur>\n          <civilite code=\"1\"/>\n          <nom>Parmelane</nom>\n          <prenom>Marie-Anne</prenom>\n          <dateNaissance>2019-12-05</dateNaissance>\n          <nationalite code=\"FRA\"/>\n          <situationFamiliale code=\"M\"/>\n          <mel>comptetest.a.ls@gmail.com</mel>\n          <adressePostale>\n            <etranger>0</etranger>\n            <voie>jkikk</voie>\n            <codePostal>75013</codePostal>\n            <commune code=\"75113\"/>\n          </adressePostale>\n          <situationProfessionnelle>\n            <typeContratTravail code=\"RET\"/>\n            <multiEmployeur>0</multiEmployeur>\n          </situationProfessionnelle>\n          <revenuFiscal>\n            <anneeMoins1>2017</anneeMoins1>\n            <montantMoins1>442</montantMoins1>\n          </revenuFiscal>\n          <listeRessourceRecue/>\n          <listeRessourceVersee/>\n          <listeRessourceRecuePersACharge/>\n          <listeRessourceVerseePersACharge/>\n        </demandeur>\n        <adresseLogement>\n          <etranger>0</etranger>\n          <voie>5</voie>\n          <codePostal>75013</codePostal>\n          <commune code=\"75113\"/>\n        </adresseLogement>\n        <logementActuel>\n          <listeModeleLogement>\n            <modeleLogement code=\"T1\"/>\n          </listeModeleLogement>\n          <montantMensuelLoyer>0</montantMensuelLoyer>\n          <proprietaire>0</proprietaire>\n          <etranger>0</etranger>\n        </logementActuel>\n      </personnePhysique>\n    </demandeLogement>\n  </demande>\n</interfaceNuu>\n"
=end
